## opendht 2.1.10

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (opendht)

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(FindPkgConfig)
include(cmake/CheckAtomic.cmake)

set (opendht_VERSION_MAJOR 2)
set (opendht_VERSION_MINOR 1.9)
set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
set (PACKAGE_VERSION ${opendht_VERSION})
set (VERSION "${opendht_VERSION}")

# Options
option (OPENDHT_STATIC "Build static library" ON)
option (OPENDHT_SHARED "Build shared library" ON)
option (OPENDHT_LOG "Build with logs" ON)
option (OPENDHT_PYTHON "Build Python bindings" OFF)
option (OPENDHT_TOOLS "Build DHT tools" ON)
option (OPENDHT_SYSTEMD "Install systemd module" OFF)
option (OPENDHT_SYSTEMD_UNIT_FILE_LOCATION "Where to install systemd unit file")
option (OPENDHT_ARGON2 "Use included argon2 sources" OFF)
option (OPENDHT_LTO "Build with LTO" OFF)
option (OPENDHT_SANITIZE "Build with address sanitizer and stack protector" OFF)
option (OPENDHT_PROXY_SERVER "Enable DHT proxy server, use Restinio and jsoncpp" OFF)
option (OPENDHT_PUSH_NOTIFICATIONS "Enable push notifications support" OFF)
option (OPENDHT_PROXY_SERVER_IDENTITY "Allow clients to use the node identity" OFF)
option (OPENDHT_PROXY_CLIENT "Enable DHT proxy client, use Restinio and jsoncpp" OFF)
option (OPENDHT_PROXY_OPENSSL "Build DHT proxy with OpenSSL" ON)
option (OPENDHT_PROXY_HTTP_PARSER_FORK "Build DHT proxy with custom http_parser to support old API" OFF)
CMAKE_DEPENDENT_OPTION(OPENDHT_HTTP "Build embedded http(s) client" OFF "NOT OPENDHT_PROXY_SERVER;NOT OPENDHT_PROXY_CLIENT" ON)
option (OPENDHT_PEER_DISCOVERY "Enable multicast peer discovery" ON)
option (OPENDHT_INDEX "Build DHT indexation feature" OFF)
option (OPENDHT_TESTS "Add unit tests executable" OFF)
option (OPENDHT_TESTS_NETWORK "Enable unit tests that require network access" ON)
option (OPENDHT_C "Build C bindings" OFF)

find_package(Doxygen)
option (OPENDHT_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})

# Dependencies
list (APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
if (NOT MSVC)
    set (THREADS_PREFER_PTHREAD_FLAG TRUE)
    find_package (Threads)
    find_package (PkgConfig REQUIRED)
    find_package (GnuTLS 3.3 REQUIRED)
    pkg_search_module (Nettle nettle)
    find_package (Msgpack 1.2 REQUIRED)
    if (OPENDHT_TOOLS)
        find_package (Readline 6 REQUIRED)
    endif ()
    if (NOT OPENDHT_ARGON2)
        pkg_search_module(argon2 libargon2)
        if (argon2_FOUND)
            message("-- Found Argon2: " ${argon2_LIBRARY_DIRS} " (found version \"" ${argon2_VERSION} "\")")
            link_directories (${argon2_LIBRARY_DIRS})
        else ()
            message("Argon2 not found, using included version.")
            set(OPENDHT_ARGON2 ON)
        endif()
    endif ()

    pkg_search_module(Jsoncpp jsoncpp)
    if (Jsoncpp_FOUND)
        add_definitions(-DOPENDHT_JSONCPP)
        list (APPEND opendht_SOURCES
          src/base64.h
          src/base64.cpp
        )
    endif()

    if (OPENDHT_HTTP)
        find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
        find_package(Restinio REQUIRED)
        find_library(FMT_LIBRARY fmt)
        add_library(fmt SHARED IMPORTED)
        find_library(HTTP_PARSER_LIBRARY http_parser)
        add_library(http_parser SHARED IMPORTED)
        if (NOT Jsoncpp_FOUND)
            message(SEND_ERROR "Jsoncpp is required for DHT proxy support")
        endif()
        if (OPENDHT_PROXY_OPENSSL)
            # https://cmake.org/cmake/help/latest/module/FindOpenSSL.html
            pkg_search_module(OPENSSL REQUIRED openssl)
            if (OPENSSL_FOUND)
                message(STATUS "Found OpenSSL ${OPENSSL_VERSION} ${OPENSSL_INCLUDE_DIRS}")
                include_directories(SYSTEM ${OPENSSL_INCLUDE_DIRS})
                link_directories (${OPENSSL_LIBRARY_DIRS})
            else ()
                message(SEND_ERROR "OpenSSL is required for DHT proxy as specified")
            endif()
        endif()
        if (OPENDHT_PROXY_HTTP_PARSER_FORK)
            add_definitions(-DOPENDHT_PROXY_HTTP_PARSER_FORK)
        endif()
    else ()
        set(OPENDHT_PROXY_OPENSSL OFF)
    endif ()
else ()
    set (WIN32_DEP_DIR ${PROJECT_SOURCE_DIR}/../)
    include_directories(${WIN32_DEP_DIR}/../msvc/include) # SMP gnutls
    include_directories(${WIN32_DEP_DIR}/argon2/include)
    include_directories(${WIN32_DEP_DIR}/jsoncpp/include)
    list (APPEND opendht_SOURCES
        src/base64.h
        src/base64.cpp
    )
    add_definitions(-DOPENDHT_JSONCPP)
    include_directories(${WIN32_DEP_DIR}/msgpack-c/include)
    if (OPENDHT_HTTP OR OPENDHT_PEER_DISCOVERY)
        include_directories(
            ${WIN32_DEP_DIR}/asio/asio/include
            ${WIN32_DEP_DIR}/openssl/include
            ${WIN32_DEP_DIR}/restinio/dev
            ${WIN32_DEP_DIR}/fmt/include
            ${WIN32_DEP_DIR}/http_parser
        )
    endif ()
endif ()

if (OPENDHT_HTTP OR OPENDHT_PEER_DISCOVERY)
    add_definitions(-DASIO_STANDALONE)
endif()

# Build flags
set (CMAKE_CXX_STANDARD 14)
set (CMAKE_CXX_STANDARD_REQUIRED on)

if (NOT MSVC)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
    if (OPENDHT_SANITIZE)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fstack-protector-strong")
    endif ()
else ()
    add_definitions(-D_WINSOCK_DEPRECATED_NO_WARNINGS
                    -D_CRT_SECURE_NO_WARNINGS
                    -DWIN32_LEAN_AND_MEAN
                    -DSTATIC_GETOPT
                    -DGNUTLS_INTERNAL_BUILD)
    set(DISABLE_MSC_WARNINGS "/wd4101 /wd4244 /wd4267 /wd4273 /wd4804 /wd4834 /wd4996")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DISABLE_MSC_WARNINGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
endif ()
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMSGPACK_DISABLE_LEGACY_NIL -DMSGPACK_DISABLE_LEGACY_CONVERT")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()
add_definitions(-DPACKAGE_VERSION="${opendht_VERSION}")
if (OPENDHT_LOG)
    add_definitions(-DOPENDHT_LOG=true)
else ()
    add_definitions(-DOPENDHT_LOG=false)
endif()
if (OPENDHT_LTO AND NOT MSVC)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
    if (CMAKE_COMPILER_IS_GNUCC)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fuse-linker-plugin")
        set (CMAKE_AR        "gcc-ar")
        set (CMAKE_NM        "gcc-nm")
        set (CMAKE_RANLIB    "gcc-ranlib")
    endif ()
endif ()

if (MSGPACK_INCLUDE_DIRS)
    include_directories (SYSTEM "${MSGPACK_INCLUDE_DIRS}")
endif ()
if (GNUTLS_INCLUDE_DIRS)
    include_directories (SYSTEM "${GNUTLS_INCLUDE_DIRS}")
endif ()
if (Nettle_INCLUDE_DIRS)
    include_directories (SYSTEM "${Nettle_INCLUDE_DIRS}")
endif ()
if (ASIO_INCLUDE_DIR)
    include_directories (SYSTEM "${ASIO_INCLUDE_DIR}")
endif ()
if (Restinio_INCLUDE_DIR)
    include_directories (SYSTEM "${Restinio_INCLUDE_DIR}")
endif ()
if (Jsoncpp_INCLUDE_DIRS)
    include_directories (SYSTEM "${Jsoncpp_INCLUDE_DIRS}")
endif ()
link_directories (${Nettle_LIBRARY_DIRS})
link_directories (${Jsoncpp_LIBRARY_DIRS})
include_directories (
    ./
    include/
    include/opendht/
    ${CMAKE_CURRENT_BINARY_DIR}/include/
)

# Install dirs
include (GNUInstallDirs)
set (prefix ${CMAKE_INSTALL_PREFIX})
set (exec_prefix "\${prefix}")
set (libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set (includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set (bindir "${CMAKE_INSTALL_FULL_BINDIR}")
set (sysconfdir "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
set (top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")

# Sources
list (APPEND opendht_SOURCES
    src/utils.cpp
    src/infohash.cpp
    src/crypto.cpp
    src/default_types.cpp
    src/node.cpp
    src/value.cpp
    src/dht.cpp
    src/op_cache.cpp
    src/storage.h
    src/listener.h
    src/search.h
    src/value_cache.h
    src/op_cache.h
    src/net.h
    src/parsed_message.h
    src/request.h
    src/callbacks.cpp
    src/routing_table.cpp
    src/node_cache.cpp
    src/network_engine.cpp
    src/securedht.cpp
    src/dhtrunner.cpp
    src/log.cpp
    src/network_utils.cpp
    src/thread_pool.cpp
)

list (APPEND opendht_HEADERS
    include/opendht/def.h
    include/opendht/utils.h
    include/opendht/sockaddr.h
    include/opendht/rng.h
    include/opendht/crypto.h
    include/opendht/infohash.h
    include/opendht/default_types.h
    include/opendht/node.h
    include/opendht/value.h
    include/opendht/dht.h
    include/opendht/dht_interface.h
    include/opendht/callbacks.h
    include/opendht/routing_table.h
    include/opendht/node_cache.h
    include/opendht/network_engine.h
    include/opendht/scheduler.h
    include/opendht/rate_limiter.h
    include/opendht/securedht.h
    include/opendht/log.h
    include/opendht/log_enable.h
    include/opendht/thread_pool.h
    include/opendht/network_utils.h
    include/opendht.h
)

if (OPENDHT_PEER_DISCOVERY)
    list (APPEND opendht_SOURCES src/peer_discovery.cpp)
    list (APPEND opendht_HEADERS include/opendht/peer_discovery.h)
    add_definitions(-DOPENDHT_PEER_DISCOVERY)
endif()

if (OPENDHT_PYTHON)
    message("Indexation enabled since it is required for Python support")
    set(OPENDHT_INDEX ON)
endif()
if (OPENDHT_INDEX)
    list (APPEND opendht_SOURCES src/indexation/pht.cpp)
    list (APPEND opendht_HEADERS include/opendht/indexation/pht.h)
    add_definitions(-DOPENDHT_INDEXATION)
endif()

if (OPENDHT_PROXY_SERVER)
  add_definitions(-DOPENDHT_PROXY_SERVER)
  if (OPENDHT_PROXY_SERVER_IDENTITY)
    add_definitions(-DOPENDHT_PROXY_SERVER_IDENTITY)
  endif()
  list (APPEND opendht_HEADERS
    include/opendht/dht_proxy_server.h
  )
  list (APPEND opendht_SOURCES
    src/dht_proxy_server.cpp
  )
endif ()

if (OPENDHT_PROXY_CLIENT)
  add_definitions(-DOPENDHT_PROXY_CLIENT)
  list (APPEND opendht_HEADERS
    include/opendht/dht_proxy_client.h
  )
  list (APPEND opendht_SOURCES
    src/dht_proxy_client.cpp
  )
endif ()

if (OPENDHT_HTTP)
  if (OPENDHT_PUSH_NOTIFICATIONS)
    message("Using push notification")
    add_definitions(-DOPENDHT_PUSH_NOTIFICATIONS)
  endif ()
  list (APPEND opendht_HEADERS
    include/opendht/proxy.h
    include/opendht/http.h
    src/compat/os_cert.h
  )
  list (APPEND opendht_SOURCES
    src/http.cpp
    src/compat/os_cert.cpp
  )
endif ()

if(OPENDHT_ARGON2)
    # make sure argon2 submodule is up to date and initialized
    message("Initializing Argon2 submodule")
    execute_process(COMMAND git submodule update --init)

    # add local argon2 files to build
    list (APPEND opendht_SOURCES
        argon2/src/argon2.c
        argon2/src/core.c
        argon2/src/blake2/blake2b.c
        argon2/src/thread.c
        argon2/src/ref.c
        argon2/src/encoding.c
    )
    include_directories(argon2/include/)
endif()

if (MSVC)
    list (APPEND opendht_HEADERS src/compat/msvc/unistd.h)
endif ()

# Targets
if (OPENDHT_STATIC)
    if (NOT MSVC)
        add_library (opendht-static STATIC
            ${opendht_SOURCES}
            ${opendht_HEADERS}
        )
        set_target_properties (opendht-static PROPERTIES OUTPUT_NAME "opendht")
        if (OPENDHT_ARGON2)
            target_include_directories(opendht-static SYSTEM PRIVATE argon2)
        else ()
            target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
        endif ()
        target_link_libraries(opendht-static
            PRIVATE  ${argon2_LIBRARIES}
            PUBLIC ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_STATIC_LIBRARIES}
                   ${Jsoncpp_STATIC_LIBRARIES} ${FMT_LIBRARY} ${HTTP_PARSER_LIBRARY}
                   ${OPENSSL_STATIC_LIBRARIES})
    else ()
        if (OPENDHT_TOOLS)
            function (add_obj_lib name libfile)
                add_library(${name} OBJECT IMPORTED)
                set_property(TARGET ${name} PROPERTY IMPORTED_OBJECTS ${libfile})
            endfunction ()

=== debian/changelog ===
opendht (2.1.10-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 28 Jun 2021 12:37:27 -0700

opendht (2.1.10-1) unstable; urgency=medium

  * New upstream version. (Closes: 978562)

 -- Alexandre Viau <aviau@debian.org>  Fri, 01 Jan 2021 14:02:19 -0500

opendht (2.1.9.5-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * New upstream version.

  [ Amin Bandali ]
  * Bump debhelper compat level up to 10.

 -- Alexandre Viau <aviau@debian.org>  Tue, 08 Dec 2020 17:56:05 -0500

=== debian/control ===
Source: opendht
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Alexandre Viau <aviau@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.20160709),
               dh-exec,
               libargon2-0-dev,
               libasio-dev,
               libfmt-dev,
               libgnutls28-dev,
               libhttp-parser-dev,
               libjsoncpp-dev,
               libmsgpack-dev (>= 1.2),
               libncurses5-dev,
               libreadline6-dev,
               librestinio-dev,
               libssl-dev,
               nettle-dev,
               pkg-config
Standards-Version: 4.0.0
Homepage: https://github.com/savoirfairelinux/opendht
Vcs-Git: https://salsa.debian.org/debian/opendht.git
Vcs-Browser: https://salsa.debian.org/debian/opendht
Rules-Requires-Root: no

Package: libopendht-dev
Architecture: any
Section: libdevel
Depends: libargon2-0-dev,
         libasio-dev,
         libfmt-dev,
         libgnutls28-dev,
         libhttp-parser-dev,
         libjsoncpp-dev,
         libmsgpack-dev (>= 1.2),
         libncurses5-dev,
         libreadline6-dev,
         librestinio-dev,
         libssl-dev,
         nettle-dev,
         ${misc:Depends}
Provides: libopendht-dev
Breaks: libopendht1 (<< 1.2.1~dfsg1-6)
Replaces: libopendht1 (<< 1.2.1~dfsg1-6)
Multi-Arch: same
Description: Development files for the libopendht library
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
 .
 This package contains the static library and headers.

Package: dhtnode
Architecture: any
Section: net
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Description: OpenDHT node binary
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
 .
 This package contains the OpenDHT node binary.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CONFIGURE_FLAGS += -DOPENDHT_STATIC=ON
CONFIGURE_FLAGS += -DOPENDHT_SHARED=OFF
CONFIGURE_FLAGS += -DCMAKE_POSITION_INDEPENDENT_CODE=ON
CONFIGURE_FLAGS += -DOPENDHT_PROXY_SERVER=ON
CONFIGURE_FLAGS += -DOPENDHT_PROXY_CLIENT=ON
CONFIGURE_FLAGS += -DOPENDHT_PUSH_NOTIFICATIONS=ON

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- ${CONFIGURE_FLAGS}

override_dh_installinit:
	echo override_dh_installinit

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## opendht 2.1.10-1%2B10.0trisquel1

=== debian/changelog ===
opendht (2.1.10-1+10.0trisquel1) nabia; urgency=medium

  * Backported from Hirsute

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 29 Sep 2021 12:15:10 +0000

## opendht 2.3.1

=== tools/CMakeLists.txt ===
if (OPENDHT_SHARED)
    set (OPENDHT_LIBS opendht)
else ()
    set (OPENDHT_LIBS opendht-static)
    if (MSVC)
        set (MSC_COMPAT_SOURCES ${MSC_COMPAT_DIR}/wingetopt.c)
    endif ()
endif ()

function (configure_tool name extra_files)
    add_executable (${name} ${name}.cpp ${extra_files})
    target_link_libraries (${name} LINK_PUBLIC ${READLINE_LIBRARIES})
    target_link_libraries (${name} LINK_PUBLIC ${OPENDHT_LIBS})
    if (MSVC)
        target_sources(${name} PRIVATE ${MSC_COMPAT_SOURCES})
        target_include_directories (${name} PRIVATE ${MSC_COMPAT_DIR})
    endif ()
endfunction ()

configure_tool (dhtnode tools_common.h)
configure_tool (dhtscanner tools_common.h)
configure_tool (dhtchat tools_common.h)
if (NOT MSVC)
    configure_tool (perftest tools_common.h)
endif ()
if (OPENDHT_HTTP)
    configure_tool (durl tools_common.h)
endif ()

if (OPENDHT_C)
    add_executable (dhtcnode dhtcnode.c)
    target_link_libraries (dhtcnode LINK_PUBLIC opendht-c ${READLINE_LIBRARIES})
endif ()

if (NOT DEFINED CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR bin)
endif ()

install (TARGETS dhtnode dhtscanner dhtchat RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if (OPENDHT_SYSTEMD)
    if (NOT DEFINED OPENDHT_SYSTEMD_UNIT_FILE_LOCATION)
        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} systemd --variable=systemdsystemunitdir
                        OUTPUT_VARIABLE SYSTEMD_UNIT_INSTALL_DIR)
        message("-- Using Systemd unit installation directory by pkg-config: " ${SYSTEMD_UNIT_INSTALL_DIR})
    else()
        message("-- Using Systemd unit installation directory requested: " ${OPENDHT_SYSTEMD_UNIT_FILE_LOCATION})
        set(SYSTEMD_UNIT_INSTALL_DIR ${OPENDHT_SYSTEMD_UNIT_FILE_LOCATION})
    endif()
    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_UNIT_INSTALL_DIR "${SYSTEMD_UNIT_INSTALL_DIR}")
    set (systemdunitdir "${SYSTEMD_UNIT_INSTALL_DIR}")

    configure_file (
        systemd/dhtnode.service.in
        systemd/dhtnode.service
        @ONLY
    )
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/systemd/dhtnode.service DESTINATION ${systemdunitdir})
    install (FILES systemd/dhtnode.conf DESTINATION ${sysconfdir})
    if (OPENDHT_PYTHON)
        configure_file (
            systemd/dhtcluster.service.in
            systemd/dhtcluster.service
            @ONLY
        )
        install (FILES ${CMAKE_CURRENT_BINARY_DIR}/systemd/dhtcluster.service DESTINATION ${systemdunitdir})
        install (FILES systemd/dhtcluster.conf DESTINATION ${sysconfdir})
    endif()
endif ()

=== debian/changelog ===
opendht (2.3.1-1build3) jammy; urgency=medium

  * No-change rebuild against libfmt8

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 24 Dec 2021 14:16:39 +0000

opendht (2.3.1-1build2) jammy; urgency=medium

  * No-change rebuild against libjsoncpp25

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 14 Dec 2021 07:50:23 +0000

opendht (2.3.1-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 30 Nov 2021 11:09:45 +0100

opendht (2.3.1-1) unstable; urgency=medium

  [ Amin Bandali ]
  * d/watch: Update to version=4 and use newly-suggested opts format
    in the current uscan(1) manual for GitHub repositories.  This is
    motivated in part by a change in devscripts-2.21.5 that makes
    uscan die when filenamemangle fails.

  [ Alexandre Viau ]
  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Sat, 20 Nov 2021 23:59:14 -0500

=== debian/control ===
Source: opendht
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper (>= 9.20160709),
               cmake,
               dh-exec,
               pkg-config,
               libgnutls28-dev,
               libmsgpack-dev (>= 1.2),
               libreadline6-dev,
               libncurses5-dev,
               libargon2-0-dev,
               librestinio-dev,
               libasio-dev,
               libjsoncpp-dev,
               libhttp-parser-dev,
               libssl-dev,
               libfmt-dev,
               nettle-dev
Standards-Version: 4.0.0
Homepage: https://github.com/savoirfairelinux/opendht
Vcs-Git: https://salsa.debian.org/debian/opendht.git
Vcs-Browser: https://salsa.debian.org/debian/opendht
Rules-Requires-Root: no

Package: libopendht-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libgnutls28-dev,
         libmsgpack-dev (>= 1.2),
         libreadline6-dev,
         libncurses5-dev,
         libargon2-0-dev,
         librestinio-dev,
         libasio-dev,
         libjsoncpp-dev,
         libhttp-parser-dev,
         libssl-dev,
         libfmt-dev,
         nettle-dev
Provides: libopendht-dev
Breaks: libopendht1 (<< 1.2.1~dfsg1-6)
Replaces: libopendht1 (<< 1.2.1~dfsg1-6)
Multi-Arch: same
Description: Development files for the libopendht library
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
 .
 This package contains the static library and headers.

Package: dhtnode
Architecture: any
Section: net
Depends: ${misc:Depends},
         ${shlibs:Depends},
         adduser
Description: OpenDHT node binary
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
 .
 This package contains the OpenDHT node binary.

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,3 @@
 
 override_dh_installinit:
 	echo override_dh_installinit
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/savoirfairelinux/opendht/tags \
  (?:.*?/)?@ANY_VERSION@@ARCHIVE_EXT@

## opendht 2.4.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,20 @@
-cmake_minimum_required (VERSION 3.1)
+cmake_minimum_required (VERSION 3.10..3.20)
+if(POLICY CMP0073)
+  cmake_policy(SET CMP0073 NEW)
+endif()
+if(POLICY CMP0074)
+  cmake_policy(SET CMP0074 NEW)
+endif()
 project (opendht)
 
 include(CMakePackageConfigHelpers)
 include(CMakeDependentOption)
+include(CheckIncludeFileCXX)
 include(FindPkgConfig)
 include(cmake/CheckAtomic.cmake)
 
 set (opendht_VERSION_MAJOR 2)
-set (opendht_VERSION_MINOR 1.9)
+set (opendht_VERSION_MINOR 4.12)
 set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
 set (PACKAGE_VERSION ${opendht_VERSION})
 set (VERSION "${opendht_VERSION}")
@@ -20,15 +27,12 @@
 option (OPENDHT_TOOLS "Build DHT tools" ON)
 option (OPENDHT_SYSTEMD "Install systemd module" OFF)
 option (OPENDHT_SYSTEMD_UNIT_FILE_LOCATION "Where to install systemd unit file")
-option (OPENDHT_ARGON2 "Use included argon2 sources" OFF)
-option (OPENDHT_LTO "Build with LTO" OFF)
 option (OPENDHT_SANITIZE "Build with address sanitizer and stack protector" OFF)
 option (OPENDHT_PROXY_SERVER "Enable DHT proxy server, use Restinio and jsoncpp" OFF)
 option (OPENDHT_PUSH_NOTIFICATIONS "Enable push notifications support" OFF)
 option (OPENDHT_PROXY_SERVER_IDENTITY "Allow clients to use the node identity" OFF)
 option (OPENDHT_PROXY_CLIENT "Enable DHT proxy client, use Restinio and jsoncpp" OFF)
 option (OPENDHT_PROXY_OPENSSL "Build DHT proxy with OpenSSL" ON)
-option (OPENDHT_PROXY_HTTP_PARSER_FORK "Build DHT proxy with custom http_parser to support old API" OFF)
 CMAKE_DEPENDENT_OPTION(OPENDHT_HTTP "Build embedded http(s) client" OFF "NOT OPENDHT_PROXY_SERVER;NOT OPENDHT_PROXY_CLIENT" ON)
 option (OPENDHT_PEER_DISCOVERY "Enable multicast peer discovery" ON)
 option (OPENDHT_INDEX "Build DHT indexation feature" OFF)
@@ -39,61 +43,61 @@
 find_package(Doxygen)
 option (OPENDHT_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
 
+# Build flags
+set (CMAKE_CXX_STANDARD 17)
+set (CMAKE_CXX_STANDARD_REQUIRED on)
+
 # Dependencies
+if (NOT HAVE_CXX_ATOMICS_WITHOUT_LIB)
+    link_libraries (atomic)
+endif ()
+
 list (APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 if (NOT MSVC)
     set (THREADS_PREFER_PTHREAD_FLAG TRUE)
     find_package (Threads)
     find_package (PkgConfig REQUIRED)
-    find_package (GnuTLS 3.3 REQUIRED)
-    pkg_search_module (Nettle nettle)
-    find_package (Msgpack 1.2 REQUIRED)
+    pkg_search_module (GnuTLS REQUIRED IMPORTED_TARGET gnutls)
+    pkg_search_module (Nettle REQUIRED IMPORTED_TARGET nettle)
+    find_package (msgpack REQUIRED NAMES msgpackc-cxx msgpack msgpack-cxx)
     if (OPENDHT_TOOLS)
         find_package (Readline 6 REQUIRED)
     endif ()
-    if (NOT OPENDHT_ARGON2)
-        pkg_search_module(argon2 libargon2)
-        if (argon2_FOUND)
-            message("-- Found Argon2: " ${argon2_LIBRARY_DIRS} " (found version \"" ${argon2_VERSION} "\")")
-            link_directories (${argon2_LIBRARY_DIRS})
-        else ()
-            message("Argon2 not found, using included version.")
-            set(OPENDHT_ARGON2 ON)
-        endif()
-    endif ()
-
-    pkg_search_module(Jsoncpp jsoncpp)
+    pkg_search_module(argon2 REQUIRED IMPORTED_TARGET libargon2)
+    set(argon2_lib ", libargon2")
+    pkg_search_module(Jsoncpp IMPORTED_TARGET jsoncpp)
     if (Jsoncpp_FOUND)
         add_definitions(-DOPENDHT_JSONCPP)
+        set(jsoncpp_lib ", jsoncpp")
         list (APPEND opendht_SOURCES
           src/base64.h
           src/base64.cpp
         )
     endif()
 
+    if (OPENDHT_HTTP OR OPENDHT_PEER_DISCOVERY)
+        find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
+    endif ()
+
     if (OPENDHT_HTTP)
-        find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
         find_package(Restinio REQUIRED)
         find_library(FMT_LIBRARY fmt)
         add_library(fmt SHARED IMPORTED)
         find_library(HTTP_PARSER_LIBRARY http_parser)
         add_library(http_parser SHARED IMPORTED)
+        set(http_parser_lib "-lhttp_parser")
         if (NOT Jsoncpp_FOUND)
             message(SEND_ERROR "Jsoncpp is required for DHT proxy support")
         endif()
         if (OPENDHT_PROXY_OPENSSL)
             # https://cmake.org/cmake/help/latest/module/FindOpenSSL.html
-            pkg_search_module(OPENSSL REQUIRED openssl)
+            pkg_search_module(OPENSSL REQUIRED IMPORTED_TARGET openssl)
             if (OPENSSL_FOUND)
                 message(STATUS "Found OpenSSL ${OPENSSL_VERSION} ${OPENSSL_INCLUDE_DIRS}")
-                include_directories(SYSTEM ${OPENSSL_INCLUDE_DIRS})
-                link_directories (${OPENSSL_LIBRARY_DIRS})
+                set(openssl_lib ", openssl")
             else ()
                 message(SEND_ERROR "OpenSSL is required for DHT proxy as specified")
             endif()
-        endif()
-        if (OPENDHT_PROXY_HTTP_PARSER_FORK)
-            add_definitions(-DOPENDHT_PROXY_HTTP_PARSER_FORK)
         endif()
     else ()
         set(OPENDHT_PROXY_OPENSSL OFF)
@@ -124,12 +128,8 @@
     add_definitions(-DASIO_STANDALONE)
 endif()
 
-# Build flags
-set (CMAKE_CXX_STANDARD 14)
-set (CMAKE_CXX_STANDARD_REQUIRED on)
-
 if (NOT MSVC)
-    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type -Wno-deprecated -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
     if (OPENDHT_SANITIZE)
         set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fstack-protector-strong")
     endif ()
@@ -143,7 +143,7 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DISABLE_MSC_WARNINGS}")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
 endif ()
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMSGPACK_DISABLE_LEGACY_NIL -DMSGPACK_DISABLE_LEGACY_CONVERT")
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMSGPACK_NO_BOOST -DMSGPACK_DISABLE_LEGACY_NIL -DMSGPACK_DISABLE_LEGACY_CONVERT")
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
@@ -154,36 +154,13 @@
 else ()
     add_definitions(-DOPENDHT_LOG=false)
 endif()
-if (OPENDHT_LTO AND NOT MSVC)
-    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
-    if (CMAKE_COMPILER_IS_GNUCC)
-        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fuse-linker-plugin")
-        set (CMAKE_AR        "gcc-ar")
-        set (CMAKE_NM        "gcc-nm")
-        set (CMAKE_RANLIB    "gcc-ranlib")
-    endif ()
-endif ()
-
-if (MSGPACK_INCLUDE_DIRS)
-    include_directories (SYSTEM "${MSGPACK_INCLUDE_DIRS}")
-endif ()
-if (GNUTLS_INCLUDE_DIRS)
-    include_directories (SYSTEM "${GNUTLS_INCLUDE_DIRS}")
-endif ()
-if (Nettle_INCLUDE_DIRS)
-    include_directories (SYSTEM "${Nettle_INCLUDE_DIRS}")
-endif ()
+
 if (ASIO_INCLUDE_DIR)
     include_directories (SYSTEM "${ASIO_INCLUDE_DIR}")
 endif ()
 if (Restinio_INCLUDE_DIR)
     include_directories (SYSTEM "${Restinio_INCLUDE_DIR}")
 endif ()
-if (Jsoncpp_INCLUDE_DIRS)
-    include_directories (SYSTEM "${Jsoncpp_INCLUDE_DIRS}")
-endif ()
-link_directories (${Nettle_LIBRARY_DIRS})
-link_directories (${Jsoncpp_LIBRARY_DIRS})
 include_directories (
     ./
     include/
@@ -311,23 +288,6 @@
   )
 endif ()
 
-if(OPENDHT_ARGON2)
-    # make sure argon2 submodule is up to date and initialized
-    message("Initializing Argon2 submodule")
-    execute_process(COMMAND git submodule update --init)
-
-    # add local argon2 files to build
-    list (APPEND opendht_SOURCES
-        argon2/src/argon2.c
-        argon2/src/core.c
-        argon2/src/blake2/blake2b.c
-        argon2/src/thread.c
-        argon2/src/ref.c
-        argon2/src/encoding.c
-    )
-    include_directories(argon2/include/)
-endif()
-
 if (MSVC)
     list (APPEND opendht_HEADERS src/compat/msvc/unistd.h)
 endif ()
@@ -340,19 +300,46 @@
             ${opendht_HEADERS}
         )
         set_target_properties (opendht-static PROPERTIES OUTPUT_NAME "opendht")
-        if (OPENDHT_ARGON2)
-            target_include_directories(opendht-static SYSTEM PRIVATE argon2)
-        else ()
-            target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
-        endif ()
+        target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
         target_link_libraries(opendht-static
-            PRIVATE  ${argon2_LIBRARIES}
-            PUBLIC ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_STATIC_LIBRARIES}
-                   ${Jsoncpp_STATIC_LIBRARIES} ${FMT_LIBRARY} ${HTTP_PARSER_LIBRARY}
-                   ${OPENSSL_STATIC_LIBRARIES})
+            PRIVATE PkgConfig::argon2
+            PUBLIC ${CMAKE_THREAD_LIBS_INIT} PkgConfig::GnuTLS PkgConfig::Nettle msgpackc-cxx
+                ${FMT_LIBRARY} ${HTTP_PARSER_LIBRARY})
+        if (Jsoncpp_FOUND)
+            target_link_libraries(opendht-static PUBLIC PkgConfig::Jsoncpp)
+        endif()
+        if (OPENDHT_PROXY_OPENSSL)
+            target_link_libraries(opendht-static PUBLIC PkgConfig::OPENSSL)
+        endif()
+        if (APPLE)
+            target_link_libraries(opendht-static PRIVATE SYSTEM "-framework CoreFoundation" "-framework Security")
+        endif()
     else ()
         if (OPENDHT_TOOLS)
             function (add_obj_lib name libfile)
                 add_library(${name} OBJECT IMPORTED)
                 set_property(TARGET ${name} PROPERTY IMPORTED_OBJECTS ${libfile})
             endfunction ()
+            add_obj_lib (win32_json ${WIN32_DEP_DIR}/../msvc/lib/x64/lib_json.lib)
+            add_obj_lib (win32_gnutls ${WIN32_DEP_DIR}/../msvc/lib/x64/libgnutls.lib)
+            add_obj_lib (win32_argon2 ${WIN32_DEP_DIR}/argon2/vs2015/Argon2Ref/vs2015/build/Argon2Ref.lib)
+            list (APPEND obj_libs
+                $<TARGET_OBJECTS:win32_json>
+                $<TARGET_OBJECTS:win32_gnutls>
+                $<TARGET_OBJECTS:win32_argon2>
+            )
+            if (OPENDHT_HTTP)
+                add_obj_lib (win32_fmt ${WIN32_DEP_DIR}/fmt/msvc/Release/fmt.lib)
+                add_obj_lib (win32_http_parser ${WIN32_DEP_DIR}/http_parser/x64/Release/http-parser.lib)
+                add_obj_lib (win32_ssl ${WIN32_DEP_DIR}/openssl/libssl_static.lib)
+                add_obj_lib (win32_crypto ${WIN32_DEP_DIR}/openssl/libcrypto_static.lib)
+                list (APPEND obj_libs
+                    $<TARGET_OBJECTS:win32_fmt>
+                    $<TARGET_OBJECTS:win32_http_parser>
+                    $<TARGET_OBJECTS:win32_ssl>
+                    $<TARGET_OBJECTS:win32_crypto>
+                )
+            endif ()
+        else ()
+            list (APPEND win32_Libs
+                ${PROJECT_SOURCE_DIR}/../../msvc/lib/x64/libgnutls.lib

=== debian/changelog ===
opendht (2.4.12-7) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * Add debian/patches/1010-man-page-formatting.patch by Jakob Haufe
    to address lintian
    warning: macro 'mF' not defined [usr/share/man/man1/dhtnode.1.gz:1].
  * Sponsor upload to unstable.

 -- Amin Bandali <bandali@gnu.org>  Wed, 22 Feb 2023 15:20:06 -0500

opendht (2.4.12-6) experimental; urgency=medium

  [ Petter Reinholdtsen ]
  * debian/libopendht-c2.symbols: Exclude symbols on hurd-i386 and sh4
    too.

  [ Amin Bandali ]
  * debian/control: Taking over the maintenance of the package; many
    thanks, Alexandre!
  * debian/libopendht-c2.symbols: Add three symbols on armel.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Mon, 20 Feb 2023 23:25:50 -0500

opendht (2.4.12-5) unstable; urgency=medium

  [ Amin Bandali ]
  * debian/libopendht-c2.symbols: Add exclusions for various symbols
    across most supported architectures per buildd.debian.org logs.

  [ Petter Reinholdtsen ]
  * debian/rules: Use DEB_BUILD_GNU_TYPE for locating build directory.
  * Sponsor upload to unstable.

 -- Amin Bandali <bandali@gnu.org>  Tue, 07 Feb 2023 16:42:22 -0500

opendht (2.4.12-4) unstable; urgency=medium

  * debian/control: Switch 'python3-all' to 'python3-all-dev:any' to
    hopefully fix builds broken with 'fatal error: Python.h: No such
    file or directory'.  Also tweak a few descriptions.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Tue, 07 Feb 2023 02:21:56 -0500

opendht (2.4.12-3) unstable; urgency=medium

  * Fix build more generally on architectures like ARM EABI (armel)
    and little-endian MIPS (mipsel) that don't have native 64-bit
    atomic operations by linking against libatomic. (Closes: #1030615)
  * Address several lintian warnings:
    - Drop usr/include/opendht/opendht_c.h from libopendht-dev;
      it already belongs in libopendht-c-dev. (Closes: #1030696)
    - debian/control: Add 'Multi-Arch: same' for libopendht2 and
      libopendht-c2.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Tue, 07 Feb 2023 01:27:18 -0500

opendht (2.4.12-2) experimental; urgency=medium

  * Switch from static to shared library.  Upstream has declared their
    API and ABI stable, therefore we now build and provide a shared
    library rather than a static one.
  * Add python3-opendht providing OpenDHT Python 3 bindings
    (Closes: #850051).
  * Add simple debian/tests/test-run-python to validate Python 3
    bindings.
  * Add OpenDHT C shared library and bindings.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Sat, 04 Feb 2023 01:07:30 -0500

opendht (2.4.12-1.2) unstable; urgency=medium

  * Fix build more generally on architectures like ARM EABI (armel)
    and little-endian MIPS (mipsel) that don't have native 64-bit
    atomic operations by linking against libatomic. (Closes: #1030615)

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Sun, 05 Feb 2023 13:10:19 -0500

opendht (2.4.12-1.1) unstable; urgency=medium

  * Attempt to fix build on armel.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Sat, 04 Feb 2023 13:02:57 -0500

opendht (2.4.12-1) unstable; urgency=medium

  * New upstream version 2.4.12.
  * debian/copyright: Remove vestigial 'Files-Excluded: src/argon2/*'
    and update copyright years.
  * Update package descriptions per upstream.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Sat, 04 Feb 2023 01:05:20 -0500

opendht (2.4.10-1) unstable; urgency=medium

  * Collab-maint upload with maintainer approval.

  * New upstream version 2.4.10 (Closes: 1016489).
    - Refreshed patches to remove fuzzies.
    - Updated package description to relect new C++17 requirement.
    - Dropped call to dh_dwz during build as it fail on
      debian/dhtnode/usr/bin/dhtnode.
  * Added patch header in pkgconfig-extras.patch.
  * Switched patches to 0000/1000/2000 naming convention.
  * Added build-essential and pkg-config as autopkgtest dependencies.
  * Changed dependency for libmsgpack-dev to prefer new libmsgpack-cxx-dev
    (Closes: #1019113).

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 27 Dec 2022 10:03:41 +0100

opendht (2.3.1-3) unstable; urgency=medium

  * Collab-maint upload with maintainer approval.

  * Updated standards version from 4.5.0 to 4.6.2.  No changes needed.
  * Switched build dependency libncurses5-dev to libncurses-dev.
  * Corrected notation for new uploader.
  * Added pkgconfig-extras.patch with libraries needed to link
    simple C++ client.
  * Added simple autopkgtest C++ build test.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 26 Dec 2022 07:55:50 +0100

opendht (2.3.1-2) unstable; urgency=medium

  * Collab-maint upload with maintainer approval.

  * Acknowledge NMU (Closes: #1026871).
  * Added Amin Bandali as uploader.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 25 Dec 2022 06:42:25 +0100

opendht (2.3.1-1.1) unstable; urgency=medium

  * Non-maintainer upload using salsa Debian team git repo.

  [ Amin Bandali ]
  * d/watch: Tweak opts to use newly-suggested format in the current
    uscan(1) manual for GitHub repositories, helping correctly detect
    new releases again (partly fixes #1016489).

  [ Federico Ceratto ]
  * Configure service sandbox (Closes: #1007163).
  * Bump up Standards-Version from 4.0.0 to 4.5.0.
  * Switch to debhelper-compat 12.

  [ Petter Reinholdtsen ]
  * Switched build and binary dependency for libargon2-0-dev to libargon2-dev
    (Closes: #1005699).

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 22 Dec 2022 22:33:19 +0100

=== debian/control ===
Source: opendht
Section: libs
Priority: optional
Maintainer: Amin Bandali <bandali@gnu.org>
Build-Depends: debhelper-compat (= 12),
               cmake,
               dh-exec,
               pkg-config,
               libgnutls28-dev,
               libmsgpack-cxx-dev | libmsgpack-dev (>= 1.2),
               libmsgpack-cxx-dev | libmsgpack-dev (<= 4.0.0),
               libreadline6-dev,
               libncurses-dev,
               libargon2-dev,
               librestinio-dev,
               libasio-dev,
               libjsoncpp-dev,
               libhttp-parser-dev,
               libssl-dev,
               libfmt-dev,
               nettle-dev,
# Python 3 bindings
               dh-python,
               python3-all-dev:any,
               python3-setuptools,
               cython3
Standards-Version: 4.6.2
Homepage: https://github.com/savoirfairelinux/opendht
Vcs-Git: https://salsa.debian.org/debian/opendht.git
Vcs-Browser: https://salsa.debian.org/debian/opendht
Rules-Requires-Root: no

Package: libopendht-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libopendht2 (=${binary:Version}),
         libgnutls28-dev,
         libmsgpack-cxx-dev | libmsgpack-dev (>= 1.2),
         libmsgpack-cxx-dev | libmsgpack-dev (<= 4.0.0),
         libreadline6-dev,
         libncurses-dev,
         libargon2-dev,
         librestinio-dev,
         libasio-dev,
         libjsoncpp-dev,
         libhttp-parser-dev,
         libssl-dev,
         libfmt-dev,
         nettle-dev
Description: Development files for the libopendht library
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the C++ library headers and other
 development files.

Package: libopendht2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Lightweight C++17 distributed hash table implementation
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the C++ shared library.

Package: libopendht-c-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libopendht-c2 (=${binary:Version}),
         libopendht-dev,
         libgnutls28-dev,
         libargon2-dev
Description: Development files for the libopendht-c library
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the C bindings library header and other
 development files.

Package: libopendht-c2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopendht2 (=${binary:Version})
Description: Lightweight C++17 distributed hash table implementation - C wrapper
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the C shared library.

Package: python3-opendht
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         libopendht2 (=${binary:Version})
Description: Python 3 bindings for libopendht C++ library
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the Python 3 bindings.

Package: dhtnode
Architecture: any
Section: net
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopendht2 (=${binary:Version}),
         adduser
Description: OpenDHT node binary
 OpenDHT is a lightweight C++17 Distributed Hash Table implementation.
 .
 OpenDHT provides an easy to use distributed in-memory data store.
 Every node in the network can read and write values to the store.
 Values are distributed over the network, with redundancy.
 .
 Overview of features:
  * Lightweight and scalable, designed for large networks and small
    devices
  * High resilience to network disruption
  * Public key cryptography layer providing optional data signature
    and encryption (using GnuTLS)
  * IPv4 and IPv6 support
  * Clean and powerful C++17 map API
  * Bindings for C and Python 3
  * REST API with optional HTTP client+server with push notification
    support
 .
 This package contains the dhtnode binary.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

# export DH_VERBOSE = 1
PYVERS = $(shell py3versions -vs)

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CONFIGURE_FLAGS += -DOPENDHT_SHARED=ON
CONFIGURE_FLAGS += -DOPENDHT_STATIC=OFF
CONFIGURE_FLAGS += -DCMAKE_POSITION_INDEPENDENT_CODE=ON
CONFIGURE_FLAGS += -DOPENDHT_PROXY_SERVER=ON
CONFIGURE_FLAGS += -DOPENDHT_PROXY_CLIENT=ON
CONFIGURE_FLAGS += -DOPENDHT_PUSH_NOTIFICATIONS=ON
CONFIGURE_FLAGS += -DOPENDHT_PYTHON=ON
CONFIGURE_FLAGS += -DOPENDHT_C=ON

%:
	dh $@ --without autoreconf --with python3

override_dh_auto_configure:
	dh_auto_configure -- ${CONFIGURE_FLAGS}

clean-python%:
	( [ -d "obj-$(DEB_BUILD_GNU_TYPE)"/python ] && \
	    cd "obj-$(DEB_BUILD_GNU_TYPE)"/python && \
	    python$* setup.py clean ) || true

build-python%:
	cd "obj-$(DEB_BUILD_GNU_TYPE)"/python && \
	  python$* setup.py build

install-python%:
	cd "obj-$(DEB_BUILD_GNU_TYPE)"/python && \
	  python$* setup.py install \
	    --root=$(CURDIR)/debian/tmp \
	    --install-layout=deb

execute_after_dh_auto_clean: $(PYVERS:%=clean-python%)
	$(RM) $(CURDIR)/python/opendht.cpp
execute_after_dh_auto_build: $(PYVERS:%=build-python%)
execute_after_dh_auto_install: $(PYVERS:%=install-python%)
	rm -f $(CURDIR)/debian/tmp/usr/share/man/man1/dhtnode.1
execute_after_dh_install:
	rm -f $(CURDIR)/debian/libopendht-dev/usr/include/opendht/opendht_c.h

override_dh_installinit:
	echo override_dh_installinit

# Skip dh_dwz set as it fail on debian/dhtnode/usr/bin/dhtnode in version 2.4.10
override_dh_dwz:
	#dh_dwz

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
  https://github.com/savoirfairelinux/opendht/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
